django/django_level_five/learning_users/basic_app/urls.py
from django.contrib import admin
from django.urls import path
from basic_app import views

app_name = 'basic_app'

urlpatterns = [
  path('index/', views.index, name='index'),
  path('base/', views.base, name='base'),
  path('register/', views.register, name='register'),
  path('user_login/', views.user_login, name='user_login'),
  ]

django/django_level_five/learning_users/learning_users/urls.py
from django.contrib import admin
from django.urls import path
from django.urls.conf import include
from basic_app import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('basic_app/', include('basic_app.urls')),
    path('user_logout/', views.user_logout, name='user_logout'),
    path('special/', views.special, name='special'),
]

django/django_level_five/learning_users/basic_app/models.py
from django.db import models
from django.contrib.auth.models import User


class UserProfileInfo(models.Model):
  user = models.OneToOneField(User, on_delete=models.CASCADE, )

  portofolio_site = models.URLField(blank=True)
  profile_pic = models.ImageField(upload_to='profile_pic', blank=True)

  def __str__(self):
    return self.user.username
# Create your models here.

django/django_level_five/learning_users/basic_app/forms.py
from django import forms
from django.contrib.auth.models import User
from django.forms import fields
from basic_app.models import UserProfileInfo

class UserForm(forms.ModelForm):
    password = forms.CharField(widget=forms.PasswordInput())

    class Meta():
        model = User
        fields = ('username', 'email', 'password')


class UserProfileInfoForm(forms.ModelForm):
    class Meta():
        model = UserProfileInfo
        fields = ('portofolio_site', 'profile_pic')

django/django_level_five/learning_users/basic_app/views.py
from django.shortcuts import render
from basic_app.forms import UserForm, UserProfileInfoForm

#
from django.contrib.auth import authenticate, login, logout
from django.http import HttpResponse, HttpResponseRedirect
from django.urls import reverse
from django.contrib.auth.decorators import login_required

def index(request):
    return render(request, 'basic_app/index.html')

def base(request):
    return render(request, 'basic_app/base.html')

def register(request):
    registered = False
    if request.method == 'POST':
        user_form = UserForm(data=request.POST)
        profile_form = UserProfileInfoForm(data=request.POST)

        if user_form.is_valid() and profile_form.is_valid():
            user = user_form.save()
            user.set_password(user.password)
            user.save()

            profile = profile_form.save(commit=False)
            profile.user = user
            if 'profile_pic' in request.FILES:
                profile.profile_pic = request.FILES['profile_pic']
            profile.save()
            registered = True
        else:
            print(user_form.errors, profile_form.errors)
    else:
        user_form = UserForm()
        profile_form = UserProfileInfoForm()
    
    return render(request, 'basic_app/registration.html', 
        {'user_form' : user_form,
        'profile_form' : profile_form,
        'registered' : registered})

@login_required
def user_logout(request):
    logout(request)
    return render(request, 'basic_app/index.html', {})

@login_required
def special(request):
    return HttpResponse('You are logged')


def user_login(request):
    if request.method == 'POST':
        print('1\n')
        username = request.POST.get('username')
        password = request.POST.get('password')
    
        user = authenticate(username = username, password = password)

        if user:
            if user.is_active:
                login(request, user)
                return render(request, 'basic_app/index.html', {})
            else:
                return HttpResponse('Account Not Active')
        else:
            print(f'Someone tried to login: Username = {username}, Password = {password}.')
            return HttpResponse('Invalid login details')
    else:
        return render(request, 'basic_app/login.html', {})

django/django_level_five/learning_users/templates/basic_app/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <title>Document</title>
</head>
<body>
    <nav class="navbar navbar-expand-lg navbar-light bg-dark">
        <div class="container">
            <ul class="nav navbar-nav">
                <li><a class="navbar-brand" href="#">Brand</a></li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'admin:index' %}">Admin</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'basic_app:index' %}">Index</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'basic_app:register' %}">Register</a>
                </li>
                {% if user.is_authenticated %}
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'user_logout' %}">Logout</a>
                </li> 
                {%else%}
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'basic_app:user_login' %}">Login</a>
                </li> 
                {%endif%}        
            </ul>
        </div>
    </nav>
    <div class="container">
        {% block body_block %}
        {% endblock %}
    </div>
</body>
</html>

django/django_level_five/learning_users/templates/basic_app/index.html
<!DOCTYPE html>
{%extends "basic_app/base.html"%}
{%load staticfiles%}
{% block body_block %}
    <h1>Index</h1>
{% endblock %}

django/django_level_five/learning_users/templates/basic_app/login.html
<!DOCTYPE html>
{% extends "basic_app/base.html" %}
{% load staticfiles %}
{% block body_block %}
<div class="jumbotron">
    <h1>Please Login</h1>
    <form action="{% url 'basic_app:user_login' %}" method="POST">
        {% csrf_token %}
        <label for="username">Username:</label>
        <input type="text" name="username" placeholder="Enter Username">

        <label for="password">Password</label>
        <input type="password" name="password">
        
        <input type="submit" name="" value="Login">

    </form>
</div>
{% endblock %}

django/django_level_five/learning_users/templates/basic_app/registration.html
<!DOCTYPE html>
{%extends "basic_app/base.html"%}
{%load staticfiles%}
{% block body_block %}

<div class="jumbotron">
    {% if registered %}
      <h1>Thank you for registering!</h1>
    {% else %}
    <h1>Resgister here</h1>
    <h3>Fill out the form</h3>
    <form action=""  enctype="multipart/form-data" method="POST">
        {%csrf_token%}
        {{user_form.as_p}}
        {{profile_form.as_p}}
        <input type="submit" value="Register">
    </form>
    {%endif%}
</div>
{% endblock %}